unit config;
interface
uses
 IniFiles, MMSystem, SysUtils;
const
 StartDir : string = '';

 MainConfigName    = 'main.ini';
 LangConfName      = 'lang.ini';
 DictionaryConfName= 'dictionary.ini';

 ConfigFolder = 'config';




// Rabbit Main Config -> GetMConf
function  GetMConf( Key : string ):string;
procedure SetMConf( Key, Value : string );
// Rabbit Languge Config -> GetLConf
function  GetLConf( Key : string ):string;
procedure SetLConf( Key, Value : string );
// Rabbit Dictionary Config -> GetLConf
function  GetDicConf( Key : string ):string;
procedure SetDicConf( Key, Value : string );

var
  LangFolder: array [1..20] of string;
  CurentLang: byte;
implementation
uses Log;
function GetConfigString( FileName, Section, Key : string ): string;
var
  Ini: TIniFile;
begin
  if FileExists( StartDir + '/' + ConfigFolder + '/' + FileName ) then
   begin
    Ini := TIniFile.Create( StartDir + '/' + ConfigFolder + '/' + FileName  );
     try
      GetConfigString := Ini.ReadString( Section, Key, '%' + Key );
     finally
      Ini.Free;
     end;
   end
  else
   begin
    GetConfigString  := '%'+Key;
    AddToLog('CONFIG','wrong key - ' + Key + ' file - ' + FileName );
   end;
end;

function SetConfigString( FileName, Section, Key, Value : string ):boolean;
var
  Ini: TIniFile;
begin
  SetConfigString := false;
  Ini := TIniFile.Create( StartDir + '/' + ConfigFolder + '/' + FileName  );
  Ini.UpdateFile;
  try
    Ini.WriteString( Section, Key, Value);
    SetConfigString := true;
  finally
    Ini.Free;
  end;
end;

function  GetMConf( Key : string ):string;
begin
  GetMConf := GetConfigString( MainConfigName,'Main',Key);
end;

procedure SetMConf( Key, Value : string );
begin
  SetConfigString( MainConfigName, 'Main', Key, Value );
end;

function  GetLConf( Key : string ):string;
begin
  GetLConf := GetConfigString( LangFolder[CurentLang] + '/' + LangConfName, 'Languge',Key);
end;

procedure SetLConf( Key, Value : string );
begin
  SetConfigString( LangFolder[CurentLang] + '/' + LangConfName, 'Languge', Key, Value );
end;

function  GetDicConf( Key : string ):string;
begin
   GetDicConf := GetConfigString( DictionaryConfName, 'Dictionary',Key);
end;

procedure SetDicConf( Key, Value : string );
begin
  SetConfigString( DictionaryConfName, 'Dictionary', Key, Value );
end;



end.
