//------------------------------------------------------------------------------
// Project Rabbit II    SAPI Speech
//       Speech.ver
// http://wtwsoft.narod.ru/build.htm
//     
//------------------------------------------------------------------------------
//     -     SpeechAPI
//   Rabbit.        
// .  SAPI4     SAPI.PAS.
//      Speech.pas  SAPI.pas  
//  SAPI,     ,    
//      .
unit Speech4;  //   
interface     //   ,         
uses  //      ,    SAPI
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   ComObj, ActiveX, SAPI4, Log;

const
  FInit: Boolean = false; //      Init

  msgNoSAPI  = 'No SPEECH API 4 install';
  msgNotInit = 'Can not init SAPI';
  msgNotFound = 'No SAPI 4 engine found';
  msgNotStarted = 'No Speech engin started';
type
//RC19
   TSpeechEngineInfo = record
      Name:             String; //   
      Language:         String; //  ,     
      Manufacturer:     String; //  ,  
      Product:          String; //   
      ModeID:           String; //  ,   
      EngineID:         String; //  ,    .        ""
      Speaker:          String; //  ,  "", ""
      Style:            String; //   
      Gender:           String; // ,      male, fmale
      Age:              Integer;//   :)
      Features:         Integer;//    
      Interfaces:       Integer;//   
      MaxPitch:         Word; //    
      MinPitch:         Word; //  
      MaxRealTime:      Longword;//   
      MinRealTime:      Longword;// 
      MaxSpeed:         Longword;//  
      MinSpeed:         Longword;// 
      MaxVolume:        Longword;//  
      MinVolume:        Longword;// 
   end;
//         ,   
//     ,     .   
//              
//        .   .
//    sdAbout         ,
//     ,     
//    sdGeneral   , 
//    sdLexicon   
//    sdTranslate  
   TSpeechDialog = (sdAbout, sdGeneral, sdLexicon, sdTranslate);

//     ""  -    .
//    soFile -     
//    soGeneral -   , Sound Blaster.
   TSpeechOutput = (soFile, soGeneral);
//RC13

   TMSAChangedEvent = procedure(Sender: TObject; Attribute: Longword) of object;
   TMSErrorEvent = procedure(Sender: TObject; Code: Integer; Message: String) of object;
   TMSVisualEvent = procedure(Sender: TObject; Hints: Longword; Mouth: PTTSMouth) of object;

type
   ESpeechException = class(Exception);

   TSpeech = class; //RC14
//RC15

   TTSNotifySink = class(TInterfacedObject, ITTSNotifySink2)
   private
      FOwner:                  TSpeech; //    TSpeech 
   protected
      //   TTSNotifySink        ,  SAPI.PAS
      function AttribChanged(dwAttribute: DWORD): HResult; stdcall;
      function AudioStart(qTimeStamp: QWORD): HResult; stdcall;
      function AudioStop(qTimeStamp: QWORD): HResult; stdcall;
      function Visual(qTimeStamp: QWORD;
                      cIPAPhoneme: AnsiChar;
                      cEnginePhoneme: AnsiChar;
                      dwHints: DWORD;
                      apTTSMouth: PTTSMouth): HResult; stdcall;

      function Error(Error: IUnknown): HResult; stdcall;
      function Warning(Warning: IUnknown): HResult; stdcall;
      function VisualFuture(dwMilliseconds: DWORD;
                            qTimeStamp: QWORD;
                            cIPAPhoneme: AnsiChar;
                            cEnginePhoneme: AnsiChar;
                            dwHints: DWORD;
                            pTTSMouth: PTTSMouth): HResult; stdcall;
   public
      constructor Create(AOwner: TSpeech);
   end;

   TTSBufNotifySink = class(TInterfacedObject, ITTSBufNotifySink)
   private
      FOwner:                  TSpeech;
   protected
      function TextDataDone(qTimeStamp: QWORD; dwFlags: DWORD): HResult; stdcall;
      function TextDataStarted(qTimeStamp: QWORD): HResult; stdcall;
      function BookMark(qTimeStamp: QWORD; dwMarkNum: DWORD): HResult; stdcall;
      function WordPosition(qTimeStamp: QWORD; dwByteOffset: DWORD): HResult; stdcall;
   public
      constructor Create(AOwner: TSpeech);
   end;
//RC16

   TSpeech = class(TComponent)
   private  //  TSpeech,   
      FEnabled:                Boolean;  //  
      FEngines:                TStrings; //      SAPI 
      FEngineStarted:          Boolean;  //    
      FFile:                   WideString; //      
      FIAF:                    IAudioFile; //   ,    SAPI.PAS
      FIAMD:                   IAudioMultimediaDevice; //   ,   SAPI.PAS
      FInfo:                   TSpeechEngineInfo; //      ,      
      FITTSAttributes:         ITTSAttributesA; //     , , , ,   SAPI.PAS
      FITTSDialogs:            ITTSDialogs;//   ()   ,SAPI.PAS
      FITTSEnum:               ITTSEnum; //     SAPI ,SAPI.PAS
      FITTSCentral:            ITTSCentralA;//    - , , ,   SAPI.PAS
      FKey:                    Longword; //    , 0       
      FOutput:                 TSpeechOutput; //     - , 
      FPaused:                 Boolean; //      
      FText:                   TStrings; //     
      FTTSNotifySink:          ITTSNotifySink2; //    , , , , SAPI.PAS
      FTTSBufNotifySink:       ITTSBufNotifySink; //     , SAPI.PAS
      FVersion, DummyS:        String; //       TSpeech
      PModeInfo:               PTTSModeInfo; //        , SAPI.PAS

      function GetInterface(Index: Integer): IUnknown; //      
      function GetPitch: Word; //  
      function GetRealTime: Longword; //   
      function GetSpeed: Longword; //   
      function GetVolume: Longword; //   
      procedure SetText(const Value: TStrings); //      TSpeech
      procedure SetPitch(const Value: Word); //  
      procedure SetRealTime(const Value: Longword); //   
      procedure SetSpeed(const Value: Longword); //  
      procedure SetVolume(const Value: Longword); //  

      procedure BeforeSelectEngine; //      ,    
      procedure Init; //       Engines  
      procedure InitAudio; //              FOutput
      procedure PostSelectEngine; //    ,     
      procedure PostSelectEngine2(ModeInfo: TTSModeInfo); //     ,    FInfo

      function GetAudioDevice: IUnknown; //       - /
   protected
     //   -   SAPI    
      FOnAttribChanged:        TMSAChangedEvent; //   
      FOnError:                TMSErrorEvent; // 
      FOnStart:                TNotifyEvent;  //  
      FOnStop:                 TNotifyEvent;  //  
      FOnWarning:              TMSErrorEvent; // 
      FOnVisual:               TMSVisualEvent;// 
      FPos:                    Longword; //  ,    

      procedure FlushFile;    //  
   public
      //RC17
      constructor Create(AOwner: TComponent); override; //  TSpeech          AOwner
      destructor Destroy; override; //  TSpeech
      procedure Inject(Command: String); //     
      procedure Pause; //  
      procedure Resume; //  
      procedure SelectEngine(EngineName: String); overload; //    
      procedure SelectEngine(EngineMode: TTSModeInfo); overload; //    
      procedure ShowDialog(DialogType: TSpeechDialog); //    
      procedure Speak; overload; //     TSpeech.Text
      procedure Speak(const Text: String); overload; //      Text
      procedure Stop; //  

      function GetEngineInfo(EngineName: String; var Info: TSpeechEngineInfo): Boolean; //       

      // ,  TSpeech,    ,  :
      // property Pitch: Word read GetPitch write SetPitch;
      //       Speech1.Pitch,  
      //      ,   a := Speech1.Pitch ( var a : word )
      //      GetPitch.     Speech1.Pitch := a
      //    SetPitch( a );

      property Interfaces[Index: Integer]: IUnknown read GetInterface; //    
      property Paused: Boolean read FPaused; //    
      property Pitch: Word read GetPitch write SetPitch; //    
      property Position: Longword read FPos; //  
      property Engines: TStrings read FEngines; //   
      property Info: TSpeechEngineInfo read FInfo; //       
      property RealTime: Longword read GetRealTime write SetRealTime; //  
      property Speed: Longword read GetSpeed write SetSpeed; //  
      property Volume: Longword read GetVolume write SetVolume; //  

   published
      //  ,     ObjectInspector
      property Enabled: Boolean read FEnabled write FEnabled; //  
      property Filename: WideString read FFile write FFile; //     
      property Output: TSpeechOutput read FOutput write FOutput; //      
      property Text: TStrings read FText write SetText; //   
      property Version: String read FVersion write DummyS; //   (   )
      //          Object Inspector   
      //  .  , Object Inspector   "-"  "-"
      //   .

      property OnAttribChanged: TMSAChangedEvent read FOnAttribChanged write FOnAttribChanged; //      SAPI   
      property OnError: TMSErrorEvent read FOnError write FOnError; //      SAPI 
      property OnStart: TNotifyEvent read FOnStart write FOnStart; //    
      property OnStop: TNotifyEvent read FOnStop write FOnStop; //   ,       Stop
      property OnWarning: TMSErrorEvent read FOnWarning write FOnWarning; // 
      property OnVisual: TMSVisualEvent read FOnVisual write FOnVisual; // 
   end;

implementation //   TSpeech,      
{$R *.res} //    , *.res ,   
           // TSAPI.RES,   TSpeech    
           //  ,     ImageEdit 
           //   Delphi
//   TSpeech,   ,  
//  ,      TSpeech 
// 
constructor TSpeech.Create(AOwner: TComponent);
begin
   AddToLog('SAPI4','Prepare to initializate');
   inherited; //       TComponent
   FEngines := TStringList.Create; //   
   FText := TStringList.Create; //     
   FKey := 0;
   FPos := 0;
   FOutput := soGeneral; //    - 
   FEnabled := True;     //  
   FPaused := False;     //  
   FVersion := 'TSpeech 1.0'; //     Object Inspector
   Init; //  !      SAPI  .
         //  ,     
         // ,   .
end;

//  TSpeech
destructor TSpeech.Destroy;
begin
   AddToLog('SAPI4','Try destroy interface object');
   FInit := False; //   
   FEngines.Free; //      
   FText.Free; //     
   if Assigned(PModeInfo) then Dispose(PModeInfo); //    
   //      
   inherited;//   TComponent.Destroy     Delphi  
   AddToLog('SAPI4','destroy ok');   
end;
//            Engines
procedure TSpeech.Init;
var
    ModeInfo: TTSModeInfo; //    
    EngineCount: Integer;  //   
    Result : dword;
begin
   FEngineStarted := False; // ,       
   FInit := False;    //   
   FEnabled := False; //    
   try //   
     //RC18
     //       CoCreateInstance   ,       
     AddToLog('SAPI4','Create engine enumerator');
     Result :=  CoCreateInstance( CLSID_TTSEnumerator, Nil, CLSCTX_ALL, IID_ITTSEnum, FITTSEnum);
     if Result = 0 then
      begin
//        ,      
//       FITTSEnum.Reset    
     AddToLog('SAPI4','Find Text-To-Speech engines');
      OleCheck( FITTSEnum.Reset );
//        FITTSEnum.Next        
//       SAPI  ,     0  EngineCount  ModeInfo   
//        ,  0,    .
      OleCheck( FITTSEnum.Next( 1, ModeInfo, @EngineCount ));
      while EngineCount > 0 do //     
      begin
         AddToLog('SAPI4','Found engine - ' + ModeInfo.szModeName);
         FEngines.Add(String(ModeInfo.szModeName)); //      TSpeech  
         OleCheck(FITTSEnum.Next(1, ModeInfo, @EngineCount)); //     EngineCount  
      end;
      FInit    := True; // ,        
      FEnabled := True;
     end;
    except //      
   end;
end;

//    ,  ,
//      Output  TSpeech     FOutput
procedure TSpeech.InitAudio;
begin
 if not FInit then Exit; // block the metod if no SAPI

   case Output of //      ?
         //    ,    FIAF,
         //          Init  TSpeech
         //        SAPI.PAS
      soFile:
         OleCheck(CoCreateInstance(CLSID_AudioDestFile, nil, CLSCTX_ALL, IID_IAudioFile, FIAF));
         //       FIAMD  CLSID_MMAudioDest
      soGeneral:
         OleCheck(CoCreateInstance(CLSID_MMAudioDest, nil, CLSCTX_ALL, IID_IAudioMultiMediaDevice, FIAMD));
   end;
end;

// ,      ,  
//    .
function TSpeech.GetAudioDevice;
begin
 if not FInit then Exit;
   case Output of //  
      soFile:  //     
         Result := FIAF; //      
      soGeneral: //  
         Result := FIAMD; //     
   end;
end;

//   Flush (   )  IAudioFile
// (  FIAF   TSpeech.InitAudio )
procedure TSpeech.FlushFile;
begin
 if not FInit then Exit;
   if FOutput = soFile then // ,      
     FIAF.Flush; //  
end;

//    (   )   , 
// FITTSCentral   Inject
procedure TSpeech.Inject;
begin
 if not(FInit) then Exit;
//         String (Command)  PChar, 
//          SAPI.     
//    Command       .

//    Command    TSpeech.Inject    
//       TSpeech

   FITTSCentral.Inject( PChar ( Command ));
end;

//     ,     SAPI   
procedure TSpeech.BeforeSelectEngine;
begin
 if not FInit then Exit;
//    - ,  TSpeech.InitAudio
   InitAudio;

//       
   if FKey > 0 then
   begin
      FITTSCentral.UnRegister(FKey); //     SAPI
      FKey := 0; //   ,  
   end;

//    /   
   FTTSBufNotifySink := TTSBufNotifySink.Create(Self); //   
   FTTSNotifySink := TTSNotifySink.Create(Self); //  SAPI
end;

//   ,      
//   Init  FITTSEnum.Next      Engines,
//      Exception (  ) (   SAPI  )
procedure TSpeech.SelectEngine(EngineName: String);
var
   Index, EngineCount: Integer;
    ModeInfo: TTSModeInfo;
begin
   AddToLog('SAPI4','Try select engine - ' + EngineName);
   if not FInit then Exit;//    ,      TSpeech.Init,
                        //  Init      




   Index := Engines.IndexOf(EngineName); //      EngineName    Engines
   if Index < 0 then //      
      raise ESpeechException.Create( msgNotFound ); //  Exception,   msgSENotFound


   //         SAPI    
   FEngineStarted := True; //        TSpeech    
   try //   
      BeforeSelectEngine; //   TSpeech.BeforeSelectEngine  
                          //         ,  
                          //  

   //           Init FITTSEnum.Next,
   //      Init  ,   FITTSEnum 

      OleCheck(FITTSEnum.Reset);         //   
      OleCheck(FITTSEnum.Skip(Index));   //   SAPI      EngineName   TSpeech.Engines
      OleCheck(FITTSEnum.Next(1, ModeInfo, @EngineCount)); //       

      if Assigned(PModeInfo) then Dispose(PModeInfo); //         ,    
      New(PModeInfo); //   
      PModeInfo^ := ModeInfo; //      PModeInfo^    ModeInfo
                              //   .

      //   ,    PModeInfo^.gModeID   EngineName
      //    FITTSCentral,    GetAudioDevice
      //         Select  FITTSEnum,
      //   TSpeech.Init
      OleCheck( FITTSEnum.Select(PModeInfo^.gModeID, FITTSCentral, GetAudioDevice));
      AddToLog('SAPI4','Selected engine - ' + PModeInfo^.szModeName);
      //     FITTSCentral      
      // (      ,    TSpeech )
      PostSelectEngine;

      PostSelectEngine2(ModeInfo);
   except
      FEngineStarted := False;
   end;
end;

//     TTSModeInfo,  SelectEngine(EngineName: String);
//  ,   
procedure TSpeech.SelectEngine(EngineMode: TTSModeInfo);
var FITTSFind: ITTSFind;
    ModeInfo: TTSModeInfo;
begin
   if not FInit then Exit;


   FEngineStarted := True;
   try
      try
         BeforeSelectEngine;
         OleCheck(CoCreateInstance(CLSID_TTSEnumerator, nil, CLSCTX_ALL, IID_ITTSFind, FITTSFind));
         OleCheck(FITTSFind.QueryInterface(IID_ITTSEnum, FITTSEnum));
         OleCheck(FITTSFind.Find(EngineMode, nil, ModeInfo));

         if Assigned(PModeInfo) then Dispose(PModeInfo);
         New(PModeInfo);
         PModeInfo^ := ModeInfo;

         OleCheck(FITTSFind.Select(PModeInfo^.gModeID, FITTSCentral, GetAudioDevice));

         PostSelectEngine;
         PostSelectEngine2(ModeInfo);
      except
         FEngineStarted := False;
      end;
   finally
      FITTSFind._Release;
   end;
end;

//   
procedure TSpeech.PostSelectEngine;
begin
 if not FInit then Exit;
//      FITTSCentral       ,
//    ,  FITTSAttributes,  QueryInterface   
//    FITTSAttributes  .      IID_ITTSAttributes  SAPI.PAS
   OleCheck(FITTSCentral.QueryInterface(IID_ITTSAttributes, FITTSAttributes));

//            FITTSDialogs
   OleCheck(FITTSCentral.QueryInterface(IID_ITTSDialogs, FITTSDialogs));

//        FTTSNotifySink  
//      .    FITTSCentral  
//     ,  
   if FITTSCentral.Register(Pointer(FTTSNotifySink), IID_ITTSNotifySink2, FKey) <> 0 then
   begin
//    
      OleCheck(FITTSCentral.Register(Pointer(FTTSNotifySink), IID_ITTSNotifySink, FKey));
   end;
end;

//    ,   FInfo
procedure TSpeech.PostSelectEngine2;
var
    CurrentPitch: Word;
    CurrentRealTime, CurrentSpeed: Longword;
begin
 if not FInit then Exit;
//              ModeInfo
//     , StrPas  
   FInfo.Language := StrPas(ModeInfo.Language.szDialect);

//       FInfo   
   with FInfo, ModeInfo do
   begin
      Name := StrPas(szModeName);
      Manufacturer := StrPas(szMfgName);
      Product := StrPas(szProductName);
      ModeID := GUIDToString(gModeID);
      EngineID := GUIDToString(gEngineID);
      Speaker := StrPas(szSpeaker);
      Style := StrPas(szStyle);

//            
      case wGender of
         0: Gender := 'NEUTRAL';
         1: Gender := 'FEMALE';
         2: Gender := 'MALE';
      end;

      Age := wAge;
      Features := dwFeatures;
      Interfaces := dwInterfaces;

//             ,
//            ,  ,  
//           
      with FITTSAttributes do
      begin
//          
         PitchGet(CurrentPitch);
         PitchSet(TTSATTR_MAXPITCH);
         PitchGet(MaxPitch);
         PitchSet(TTSATTR_MINPITCH);
         PitchGet(MinPitch);
         PitchSet(CurrentPitch);
//          
         RealTimeGet(CurrentRealTime);
         RealTimeSet(TTSATTR_MAXREALTIME);
         RealTimeGet(MaxRealTime);
         RealTimeSet(TTSATTR_MINREALTIME);
         RealTimeGet(MinRealTime);
         RealTimeSet(CurrentRealTime);
//          
         SpeedGet(CurrentSpeed);
         SpeedSet(TTSATTR_MAXSPEED);
         SpeedGet(MaxSpeed);
         SpeedSet(TTSATTR_MINSPEED);
         SpeedGet(MinSpeed);
         SpeedSet(CurrentSpeed);

//           MS's help    
         MaxVolume := 100;
         MinVolume := 0;
      end;
   end;
end;

//   
procedure TSpeech.Pause;
begin
 if not FInit then Exit;
//      FITTSCentral  AudioPause, 
//      
   OleCheck(FITTSCentral.AudioPause);
   FPaused := True; //    
end;

//    
procedure TSpeech.Resume;
begin
 if not FInit then Exit;
//     FITTSCentral  AudioResume, 
   OleCheck(FITTSCentral.AudioResume);
   FPaused := False; //    
end;

//    ,     
procedure TSpeech.ShowDialog;
begin
 if not FInit then Exit;
//     FITTSDialogs   DialogType  
   case DialogType of
      sdAbout: OleCheck(FITTSDialogs.AboutDlg(Application.Handle, PChar('')));
      sdGeneral: OleCheck(FITTSDialogs.GeneralDlg(Application.Handle, PChar('')));
      sdLexicon: OleCheck(FITTSDialogs.LexiconDlg(Application.Handle, PChar('')));
      sdTranslate: OleCheck(FITTSDialogs.TranslateDlg(Application.Handle, PChar('')));
   end;
end;

//  Text    FText  TSpeech
procedure TSpeech.Speak;
begin
   if not FInit then Exit;
   Speak(FText.Text);
end;

//   strText
procedure TSpeech.Speak(const Text: String);
var
    SData : TSData; //        SAPI.PAS
begin
  if not FInit then Exit;
//        
 if Text = '' then Exit;

//     
 if not FEnabled then Exit;

//      
 if not FEngineStarted then raise ESpeechException.Create(msgNotStarted);

//     
 FPaused := False;

 try //  
   if FOutput = soFile then //      
       if FIAF.DoSet(PWideChar(Filename), 1) < 0 then //     
            raise ESpeechException.Create('msgCannotOpenFile'); //  

  SData.dwSize := Length( Text ) + 1; //  
  SData.pData := PChar( Text );  //   

//    .   ,     TextData
//    FITTSCentral. ,       
//    SData,      FTTSBufNotifySink

  OleCheck( FITTSCentral.TextData( CHARSET_TEXT, 1, SData, Pointer(FTTSBufNotifySink), IID_ITTSBufNotifySink));
                                               //^non zero - use text

 except //   
 end;
end;

//  
procedure TSpeech.Stop;
begin
  if not FInit then Exit;
   FPaused := False; //  
//     ,     SAPI , 
//        
   OleCheck(FITTSCentral.AudioReset);
end;

//     .
//  ,  SelectEngine  PostSelect
function TSpeech.GetEngineInfo;
var
    Index, EngineCount: Integer;
    ModeInfo: TTSModeInfo;
begin

   Result := False;

   if not FInit then Exit;
   Index := Engines.IndexOf(EngineName);
   if Index < 0 then Exit;

   if FITTSEnum.Reset < 0 then Exit;
   if FITTSEnum.Skip(Index) < 0 then Exit;
   if FITTSEnum.Next(1, ModeInfo, @EngineCount) < 0 then Exit;

   { Retrieve Engine Information }
   FillChar(Result, Sizeof(Result), 0);
   Info.Language := StrPas(ModeInfo.Language.szDialect);
   with Info, ModeInfo do
   begin
      Name := StrPas(szModeName);
      Manufacturer := StrPas(szMfgName);
      Product := StrPas(szProductName);
      ModeID := GUIDToString(gModeID);
      EngineID := GUIDToString(gEngineID);
      Speaker := StrPas(szSpeaker);
      Style := StrPas(szStyle);

      case wGender of
         0: Gender := 'NEUTRAL';
         1: Gender := 'FEMALE';
         2: Gender := 'MALE';
      end;

      Age := wAge;
      Features := dwFeatures;
      Interfaces := dwInterfaces;

      MaxVolume := 100;
   end;
   Result := True;
end;

//   
function TSpeech.GetInterface;
begin
 if not FInit then Exit;
   case Index of
      0: Result := GetAudioDevice;
      1: Result := FITTSCentral;
      2: Result := FITTSAttributes;
      3: Result := FITTSDialogs;
   end;
end;

//   
function TSpeech.GetPitch;
begin
 if not FInit then Exit;
//      FITTSAttributes  PitchGet
   FITTSAttributes.PitchGet(Result);
end;

//  
procedure TSpeech.SetPitch;
begin
 if not FInit then Exit;
 FITTSAttributes.PitchSet(Value);
end;

//   
function TSpeech.GetRealTime;
begin
 if not FInit then Exit;
   FITTSAttributes.RealTimeGet(Result);
end;

//   
procedure TSpeech.SetRealTime;
begin
 if not FInit then Exit;
   FITTSAttributes.RealTimeSet(Value);
end;

//  
function TSpeech.GetSpeed;
begin
 if not FInit then Exit;
   FITTSAttributes.SpeedGet(Result);
end;

//  
procedure TSpeech.SetSpeed;
begin
 if not FInit then Exit;
 FITTSAttributes.SpeedSet(Value);
end;

//  
function TSpeech.GetVolume:longword;
var
 CurrentVolume: longword;
begin
 Result := 0;
 if not FInit then Exit;
 FITTSAttributes.VolumeGet(CurrentVolume);
 Result := LoWord(CurrentVolume) * 100 div 65535;

end;

procedure TSpeech.SetVolume(const Value: Longword); //  
var
  TempVolume: longword;
begin
 if not FInit then Exit;
 TempVolume := 65535 * Value div 100;
 TempVolume := MakeWParam(TempVolume, TempVolume);
// FITTSCentral.Inject(PChar('\Vol=' + IntToStr(TempVolume) + '\'));
 OleCheck(FITTSAttributes.VolumeSet(TempVolume));
end;
//   Value  TSpeech FText
procedure TSpeech.SetText;
begin
 if not FInit then Exit;
   FText.Assign(Value);
end;

{ TTSNotifySink }
//  TTSNotifySink  .   
//  SAPI    ,    
//    (  TSpeech )     
//     TSpeech
constructor TTSNotifySink.Create;
begin
 if not FInit then Exit;
   FOwner := AOwner; //     
end;

//   AttribChanged  TTSNotifySink      TSpeech  OnAttribChanged
function TTSNotifySink.AttribChanged(dwAttribute: DWORD): HResult;
begin
  Result := 0; //      
 if not FInit then Exit;
//          ,    
//    
   if Assigned(FOwner.FOnAttribChanged) then FOwner.FOnAttribChanged(Self, dwAttribute);

end;

//   AudioStart,   
function TTSNotifySink.AudioStart;
begin
 Result := 0;
 if not FInit then Exit;
 if Assigned(FOwner.FOnStart) then FOwner.FOnStart(Self); //     ,  
end;

//  AudioStop
function TTSNotifySink.AudioStop;
begin
 Result := 0;
 if not FInit then Exit;
 FOwner.FlushFile; //     ,       
 if Assigned(FOwner.FOnStop) then FOwner.FOnStop(Self); //   
end;

// 
function TTSNotifySink.Visual(qTimeStamp: QWORD; cIPAPhoneme: AnsiChar; cEnginePhoneme: AnsiChar; dwHints: DWORD; apTTSMouth: PTTSMouth): HResult;
begin
 Result := 0;
{ if not FInit then Exit;
 if Assigned(FOwner.FOnVisual) then FOwner.FOnVisual(Self, dwHints, apTTSMouth);}
end;

{ TTSNotifySink2 }
//   TTSNotifySink2,     SAPI.PAS

//  
function TTSNotifySink.Error;
var Err: SpchError; //  
begin
 Result := 0;
 if not FInit then Exit;
//       
   if Assigned(FOwner.FOnError) then
   begin
//           SAPI
      ISpchError(Error).LastErrorGet(Err);
//          TSpeech.OnError
      FOwner.FOnError(Self, Err.hRes, Err.szStrings);
   end;

end;

//    
function TTSNotifySink.VisualFuture;
begin
 Result := 0;
 if not FInit then Exit;
end;

//   SAPI  function TTSNotifySink.Error;
function TTSNotifySink.Warning;
var Warn: SpchError;
begin
 Result := 0;
 if not FInit then Exit;
   if Assigned(FOwner.FOnWarning) then
   begin
      ISpchError(Warning).LastErrorGet(Warn);
      FOwner.FOnWarning(Self, Warn.hRes, Warn.szStrings);
   end;

end;

{ TTSBufNotifySink }

//    
//  
constructor TTSBufNotifySink.Create;
begin
 if not FInit then Exit;
   FOwner := AOwner; //  
end;

//     ? 
function TTSBufNotifySink.BookMark;
begin
 Result := 0;
 if not FInit then Exit;
end;

//   ?
function TTSBufNotifySink.TextDataDone;
begin
 Result := 0;
 if not FInit then Exit;
end;

//   ?
function TTSBufNotifySink.TextDataStarted;
begin
 Result := 0; //  
 if not FInit then Exit;
end;

//   ?
function TTSBufNotifySink.WordPosition(qTimeStamp: QWORD; dwByteOffset: DWORD): HResult; stdcall;
begin
 Result := 0;
 if not FInit then Exit;
 FOwner.FPos := dwByteOffset; //    TSpeech.FPos   ?
end;

end.

// Have a nice SAPI,    ;)
