//------------------------------------------------------------------------------
// Project Rabbit II Open Source FreeWare
//
// http://wtwsoft.narod.ru/build.htm
// original download from http://wtwsoft.narod.ru
// mailto: wtwsoft@narod.ru
//------------------------------------------------------------------------------
unit View;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Menus,Config, jpeg, Buttons,Service,Log;
const
  CPWin1251 = 0;
  CPKOI8    = 1;
type
//   (MIDI) 
  TViewForm = class(TForm)
    procedure FormActivate(Sender: TObject);
    procedure LocalCreate;
    procedure RichEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure RichEdit1SelectionChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure WindowMenuClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure RichEdit1KeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure ConvertFromKOI8toWin;
    procedure ConvertFromWintoKoi8;
  private
  public
    RichEdit1: TRichEdit;
    WindowMenuItem: TMenuItem;
    WindowToolButton: TToolButton;
    IndexFileName : integer;

    BookMarkImages : array [1..10] of TImage;
    BookMarkLabels : array [1..10] of TLabel;
    BookMarkOffset : array [1..10] of Dword;

    f : boolean;
    CodePage : byte;
  end;
var
  ViewForm: TViewForm; //   ,    MainForm
  a : array [0..65535] of byte;
  b : array [1..10] of longint;

  Src, Str:PChar;
implementation

uses Main;
{$R *.dfm}
//     FormActivate     
//        
procedure TViewForm.FormActivate(Sender: TObject);
begin
 try
 with MainForm do //     (MainForm),        
  begin
   CloseFileItem.Enabled      := true; //      
   BoldFontItem.Enabled       := true;
   NormalFontItem.Enabled     := true;
   ItalicFontItem.Enabled     := true;
   ViewItem.Enabled       := true;
   WindowsItem.Enabled    := true;
   ReadText.Enabled       := true;
   ToolButton2.Enabled := true;
   ReadButton.Enabled  := true;
   PauseButton.Enabled := false;
  end;
 if WindowToolButton <> nil then WindowToolButton.Down := true;
 except
  AddToLog('VIEW','Except form activate');
 end;
end;
procedure TViewForm.LocalCreate;
begin
 try
 RichEdit1 := TRichEdit.Create(Self);
 RichEdit1.Parent := ViewForm;

 RichEdit1.Align := alClient;  //    
 RichEdit1.Lines.Clear;        //  
 RichEdit1.Color := StringToColor(GetMConf('rViewBgColor'));
 RichEdit1.WordWrap := StrToBool(GetMConf('rViewWordWrap'));
 RichEdit1.Font.Name := GetMConf('rViewFont');
 RichEdit1.Font.Size := StrToInt(GetMConf('rViewfontsize'));
 RichEdit1.Font.Color := StringToColor(GetMConf('rViewFontColor'));
 RichEdit1.HideSelection := false;
 RichEdit1.HideScrollBars := false;
 RichEdit1.ScrollBars := ssBoth;

 RichEdit1.Paragraph.FirstIndent := 10;


//    RichEdit1
 RichEdit1.OnKeyPress         := RichEdit1KeyPress;  //   
 RichEdit1.OnSelectionChange  := RichEdit1SelectionChange; //   
 RichEdit1.OnKeyDown :=  RichEdit1KeyDown;
 RichEdit1.SetFocus;
// Code page
  if CodePage = KOI8Page then
   begin
    MainForm.KOI8Item.Checked := true;
    MainForm.Win1251Item.Checked := false;
   end
  else
   begin
    MainForm.KOI8Item.Checked := false;
    MainForm.Win1251Item.Checked := true;
   end;

 RichEdit1SelectionChange(nil);
 f := true;
 except
  AddToLog('VIEW','Except object create');
 end;
end;

//    RichEdit KeyPress,       
//    ,       
//   \,      RichEdit.ReadOnly 
//         ,     
//     
procedure TViewForm.RichEdit1KeyPress(Sender: TObject; var Key: Char);
begin
 try
 Key := chr(0); //    
 inherited; //  RichEdit   ,     
//       Key  var,      
//    ,           
//   
 except
  AddToLog('VIEW','Except key pressed');
 end;
end;
//           RichEdit
//      
procedure TViewForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 try
 AddToLog('VIEW','Close file ' + Caption );
 with MainForm do //     ,      
  begin           //      ,     ,  
                  //    FormActivate    
   CloseFileItem.Enabled      := false;
   BoldFontItem.Enabled       := false;
   NormalFontItem.Enabled     := false;
   ItalicFontItem.Enabled     := false;
   ViewItem.Enabled       := false;
   WindowsItem.Enabled    := false;
   ReadText.Enabled       := false;

   ToolButton2.Enabled := false;

   try
    OpenFiles.Delete( IndexFileName );
   except
    AddToLog('VIEW','Except file global index delete');
   end;

   WindowsItem.Delete(MainForm.WindowsItem.IndexOf( WindowMenuItem )); //     WindowMenuItem   Windows1
   WindowToolButton.Destroy;
   Speech1.Stop; //     
  end;

  Action := caFree; //     
 except
  AddToLog('VIEW','Except form close');
 end;

end;
//     OnClick     Windows1
//            
procedure TViewForm.WindowMenuClick(Sender: TObject);
begin
 try
 Show;  //    ,      
 WindowToolButton.Down := true;
 except
  AddToLog('VIEW','Except set focuse');
 end;
end;

procedure TViewForm.FormDeactivate(Sender: TObject);
begin
 try
  if WindowToolButton <> nil then WindowToolButton.Down := false;
 except
  AddToLog('VIEW','Except set not focuse');
 end;
end;

procedure TViewForm.RichEdit1SelectionChange(Sender: TObject);
begin
 try
//        StatusBar  
 MainForm.StatusBar1.Panels[1].Text := GetLConf('sbpage')+' '+inttostr((RichEdit1.CaretPos.Y + 1) div 40 + 1) + ' ' +
  GetLConf('sbline')+' '+inttostr( RichEdit1.CaretPos.Y + 1) + ' ' +
  GetLConf('sbchar')+' '+ inttostr( RichEdit1.CaretPos.X + 1);
//        StatusBar  
// MainForm.StatusBar1.Panels[4].Text := 'size: '+ inttostr( length(RichEdit1.Text))+' byte';
 if CodePage = WIN1251Page then MainForm.StatusBar1.Panels[2].Text := WIN1251PageName;
 if CodePage = KOI8Page then MainForm.StatusBar1.Panels[2].Text := KOI8PageName;
 except
  AddToLog('VIEW','Except selection chang');
 end;
end;

procedure TViewForm.RichEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 try
 if ssCtrl in Shift then
  begin
   Case Key of
    ord('1') : if b[1] <> -1 then RichEdit1.SelStart := BookMarkOffset[1];
    ord('2') : if b[2] <> -1 then RichEdit1.SelStart := BookMarkOffset[2];
    ord('3') : if b[3] <> -1 then RichEdit1.SelStart := BookMarkOffset[3];
    ord('4') : if b[4] <> -1 then RichEdit1.SelStart := BookMarkOffset[4];
    ord('5') : if b[5] <> -1 then RichEdit1.SelStart := BookMarkOffset[5];
    ord('6') : if b[6] <> -1 then RichEdit1.SelStart := BookMarkOffset[6];
    ord('7') : if b[7] <> -1 then RichEdit1.SelStart := BookMarkOffset[7];
    ord('8') : if b[8] <> -1 then RichEdit1.SelStart := BookMarkOffset[8];
    ord('9') : if b[9] <> -1 then RichEdit1.SelStart := BookMarkOffset[9];
    ord('0') : if b[10]<> -1 then RichEdit1.SelStart := BookMarkOffset[10];
   end;
   key := 0;
  end;
  inherited;
 except
  AddToLog('VIEW','Except key down');
 end;
end;

procedure TViewForm.ConvertFromKOI8toWin;
begin
 try
  MainForm.ShowStatus('Converting...');
  Src := RichEdit1.Lines.GetText;
  CharToOem(Src, Src);
  RichEdit1.Lines.Text := StrPas(Src);

  MainForm.KOI8Item.Checked := false;
  MainForm.Win1251Item.Checked := true;
  MainForm.ShowStatus('');
 except
  AddToLog('VIEW','Except convert to KOI8');
 end;
end;

procedure TViewForm.ConvertFromWintoKoi8;
begin
 try
  MainForm.ShowStatus('Converting...');
  Src := RichEdit1.Lines.GetText;
  OemToChar(Src, Src);
  RichEdit1.Lines.Text := StrPas(Src);

  MainForm.KOI8Item.Checked := true;
  MainForm.Win1251Item.Checked := false;
  MainForm.ShowStatus('');
 except
  AddToLog('VIEW','Except convert to WIN1251');
 end;
end;


end.
